*| [JavaECS](../../README.md) | [docs](../overview.md) | [system](./dir.md) | ECSSystem[]().md*
# ECS System

| **In this Section** |
|-|
| [About](#about) |
| [Implementation](#implementation) |
| [Constructors](#constructors) |
| [Methods](#methods) |
| [Fields](#fields) |



## About
The `ECSSystem` class is intended to be extended by a more specific system implementation. 

<br>

## Implementation
See [System.md](./System.md#implementation)

<br>

## Constructors
Default constructor
``` java
public ECSSystem(){}
```

<br>

## Methods
### init
``` java
public void init(){}
```
Functionality that needs to occur at the initialisation of the system should be performed here
* `init()` should be called only once, before the system is utilised
* An example of the type of call that could be made here is opening a file

<br>

### update
``` java
public void update(){}
```
Functionality that needs to be called regularly should be defined here
* `update()` is intended to be called regularly

<br>


## Fields
### entities
``` java
Set<Integer> entities = new HashSet<>();
```
The list of entities associated with this system

<br>

## Examples

<br>

## Notes